package com.mashangban.example.utils;

import java.security.MessageDigest;
import java.util.Arrays;

import org.apache.commons.codec.binary.Hex;

/**
 * JSSDK生成签名示例
 */
public class JssdkUtil {
	
	/**
	 * 生成jssdk权限验证签名
	 */
	public static String generateJssdkSignature(String nonce, String timestamp, String ticket, String url) {
		String[] arr = new String[] { nonce, timestamp, ticket, url };
		return generateSign(arr);
	}
	
	public static String generateSign(String[] arr){
		if(null == arr || arr.length == 0){
			return null;
		}
		// 将参数进行字典序排序
		Arrays.sort(arr);
		//将参数字符串拼接成一个字符串进行sha1签名
		StringBuilder content = new StringBuilder();
		for (int i = 0; i < arr.length; i++) {
			content.append(arr[i]);
		}
		//进行sha1签名
		return digest(content.toString(), "SHA1");
	}
	
	//进行数据签名
	public static String digest(String value, String algorithm) {
		if (value == null) {
			return null;
		}
		try {
			MessageDigest messageDigest = MessageDigest.getInstance(algorithm);
			messageDigest.update(value.getBytes("UTF-8"));
			return Hex.encodeHexString(messageDigest.digest());
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}
	
}
